import java.lang.Math;
import java.io.*;

/**
 * Created by IntelliJ IDEA.
 * User: k.rafati
 * Date: Oct 31, 2003
 * Time: 10:02:08 AM
 * To change this template use Options | File Templates.
 */
public class OutputFile extends FileHandler{
    private byte currentbyte;
    private final int FIRST_SIZE = 20;

    private void addByte2array( byte b){
        if( bytecount >= bytes.length){
            byte[] temp = new byte[bytes.length * 2];

            for( int i = 0; i < bytes.length; i++)
                temp[i] = bytes[i];

            bytes = temp;
        }

        bytes[bytecount++] = b;
    }

    public OutputFile(String name){
        super(name);
        bitcount=bytecount=0;
        bytes = new byte[FIRST_SIZE];
        currentbyte = 0;
    }
    public void addBit(boolean b){
        if( b){
            currentbyte |= (byte)Math.pow( 2, 7 - bitcount);
        }

        bitcount++;

        if( bitcount == 8){
            addByte2array( currentbyte);
            bitcount = 0;
            currentbyte = 0;
        }
    }
    public void addByte(byte b){
        if( bitcount == 0)
        {
            addByte2array( b);
            return;
        }
        //else
        currentbyte |= (byte)(((char)(b)&255) >>> bitcount);
        addByte2array( currentbyte);
        currentbyte = (byte)(b << (8 - bitcount));
    }
    public void close(){
        if(bitcount != 0)
            addByte2array(currentbyte);
        try{
            file.write(bytes,0,bytecount);
            file.close();
        }catch(IOException e){}
    }
}