
import java.io.RandomAccessFile;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: Naeem
 * Date: Oct 31, 2003
 * Time: 10:01:33 PM
 * To change this template use Options | File Templates.
 */
public class Zip {
    private CodeTableCell [] codetable;
    private RandomAccessFile inputfile;
    private OutputFile outfile;

    public Zip( String path, String destination){
        try{
            inputfile = new RandomAccessFile( path, "rw");
            TreeMaker mytree = new TreeMaker( inputfile);
            inputfile.seek( 0);

            codetable = new CodeTableCell [mytree.getSymnum()];

            for( int i = 0; i < mytree.getSymnum();i++)
                codetable[i] = (CodeTableCell)(mytree.getMysymbols().get(i));

            outfile = new OutputFile( destination);

            mytree.getTree().dumper( outfile);
            zipper();
        }catch(FileNotFoundException e){
        }catch(IOException e){}
    }

    private void zipper(){
        try {
            boolean[] thecode = null;

            for( int i = 0; i < inputfile.length();i++ ){
                thecode = findCode( (byte)inputfile.read());

                if( thecode == null)
                    throw new Exception("Khodam sakhtam nabayad nabashe");

                for( int j = 0;j < thecode.length;j++)
                    outfile.addBit( thecode[j]);
            }

            outfile.close();
        } catch (IOException e) {
        } catch (Exception e) {
        }
    }

    private boolean [] findCode( byte key){
        for( int i = 0;i < codetable.length;i++)
            if( codetable[i].getSymbol() == key)
                return codetable[i].getMybytes();

        return null;
    }

    public static void main( String [] args){
        String temp;
//        try {
            Zip z = new Zip( "n.txt", "zipped.z");
            z = null;
//        } catch (IndexOutOfBoundsException e) {
//            temp = e.getMessage();
//            temp = "";
//        }
    }
}
